diff --git xscreensaver-5.12/driver/lock.c xscreensaver-5.12/driver/lock.c
--- xscreensaver-5.12/driver/lock.c
+++ xscreensaver-5.12/driver/lock.c
@@ -21,8 +21,13 @@
 #include <X11/Intrinsic.h>
 #include <X11/cursorfont.h>
 #include <X11/Xos.h>		/* for time() */
+#include <X11/Xatom.h>
 #include <time.h>
 #include <sys/time.h>
+#include <errno.h>
+#include <gconf/gconf-client.h>
+#include "exec.h"
+#include "dialog-data.h"
 #include "xscreensaver.h"
 #include "resources.h"
 #include "mlstring.h"
@@ -83,114 +88,631 @@ vms_passwd_valid_p(char *pw, Bool verbose_p)
 
 typedef struct info_dialog_data info_dialog_data;
 
-struct passwd_dialog_data {
-
-  saver_screen_info *prompt_screen;
-  int previous_mouse_x, previous_mouse_y;
-
-  char typed_passwd [80];
-  XtIntervalId timer;
-  int i_beam;
-
-  float ratio;
-  Position x, y;
-  Dimension width;
-  Dimension height;
-  Dimension border_width;
-
-  Bool echo_input;
-  Bool show_stars_p; /* "I regret that I have but one asterisk for my country."
-                        -- Nathan Hale, 1776. */
-
-  char *heading_label;
-  char *body_label;
-  char *user_label;
-  mlstring *info_label;
-  /* The entry field shall only be displayed if prompt_label is not NULL */
-  mlstring *prompt_label;
-  char *date_label;
-  char *passwd_string;
-  Bool passwd_changed_p; /* Whether the user entry field needs redrawing */
-  Bool caps_p;		 /* Whether we saw a keypress with caps-lock on */
-  char *unlock_label;
-  char *login_label;
-  char *uname_label;
-
-  Bool show_uname_p;
-
-  XFontStruct *heading_font;
-  XFontStruct *body_font;
-  XFontStruct *label_font;
-  XFontStruct *passwd_font;
-  XFontStruct *date_font;
-  XFontStruct *button_font;
-  XFontStruct *uname_font;
-
-  Pixel foreground;
-  Pixel background;
-  Pixel passwd_foreground;
-  Pixel passwd_background;
-  Pixel thermo_foreground;
-  Pixel thermo_background;
-  Pixel shadow_top;
-  Pixel shadow_bottom;
-  Pixel button_foreground;
-  Pixel button_background;
-
-  Dimension preferred_logo_width, logo_width;
-  Dimension preferred_logo_height, logo_height;
-  Dimension thermo_width;
-  Dimension internal_border;
-  Dimension shadow_width;
-
-  Dimension passwd_field_x, passwd_field_y;
-  Dimension passwd_field_width, passwd_field_height;
-
-  Dimension unlock_button_x, unlock_button_y;
-  Dimension unlock_button_width, unlock_button_height;
-
-  Dimension login_button_x, login_button_y;
-  Dimension login_button_width, login_button_height;
-
-  Dimension thermo_field_x, thermo_field_y;
-  Dimension thermo_field_height;
-
-  Pixmap logo_pixmap;
-  Pixmap logo_clipmask;
-  int logo_npixels;
-  unsigned long *logo_pixels;
-
-  Cursor passwd_cursor;
-  Bool unlock_button_down_p;
-  Bool login_button_down_p;
-  Bool login_button_p;
-  Bool login_button_enabled_p;
-  Bool button_state_changed_p; /* Refers to both buttons */
-
-  Pixmap save_under;
-  Pixmap user_entry_pixmap;
-};
+/* struct passwd_dialog_data moved to dialog-data.h */
 
+#ifndef HAVE_XSCREENSAVER_LOCK
 static void draw_passwd_window (saver_info *si);
+#endif
 static void update_passwd_window (saver_info *si, const char *printed_passwd,
 				  float ratio);
 static void destroy_passwd_window (saver_info *si);
+static int ignore_all_errors_ehandler (Display *dpy, XErrorEvent *error);
 static void undo_vp_motion (saver_info *si);
+#ifndef HAVE_XSCREENSAVER_LOCK
 static void finished_typing_passwd (saver_info *si, passwd_dialog_data *pw);
+#endif
 static void cleanup_passwd_window (saver_info *si);
 static void restore_background (saver_info *si);
 
 extern void xss_authenticate(saver_info *si, Bool verbose_p);
 
+#ifdef HAVE_XSCREENSAVER_LOCK
+
+#define WIN_ALLOC_INCREMENT 8	/* allocate entries in the window lists in
+                                   increments of 8 at a time for fewer
+                                   reallocs and less chance of malloc error
+                                   at the wrong time */
+#define EXTRA_RAISE_WIN_SLOTS 4 /* Need to leave four extra slots free in
+                                   raise_wins to allow calling XRestackWindows
+                                   when a window pops up without having to
+                                   realloc or copy to a new list.
+                                   These slots would be used by:
+                                   - passwd_dialog
+                                   - stderr_overlay_window
+                                   - xscreensaver virtual root
+                                   - an interloper popup we need to hide
+                                */
+
+extern Atom XA_UNLOCK_RATIO;
+
+Bool g_passwd_dialog_created = 0;
+
+GConfClient *client = NULL;
+
+static const char *switch_windows_gconf_key
+  = "/apps/metacity/global_keybindings/switch_windows";
+static char  *global_switch_key = NULL;
+
+static const char *main_menu_gconf_key
+  = "/apps/metacity/global_keybindings/panel_main_menu";
+static char  *global_menu_key = NULL;
+
+extern Bool safe_XDestroyWindow (Display *dpy, Window window);
+static Bool safe_XRestackWindows(Display *dpy, Window windows[], int nwindows);
+static Bool safe_XSendEvent(Display *dpy, Window w, Bool propagate,
+                            long event_mask, XEvent *event_send);
+static void passwd_animate_timer (XtPointer closure, XtIntervalId *id);
+extern void swallow_unlock_typeahead_events (saver_info *si, XEvent *e);
+
+
+static saver_screen_info *
+find_screen_for_window (saver_info *si, Window wid)
+{
+  saver_screen_info *ssi;
+  Screen *screen;
+  Window root, root_ret, parent_ret, *children = NULL;
+  unsigned int nchildren = 0;
+  int screen_no, status;
+
+  status = XQueryTree (si->dpy, wid, &root_ret, &parent_ret,
+                       &children, &nchildren);
+
+  if (status == 0) /* failed */
+    return NULL;
+
+  XFree(children);
+  children = NULL;
+
+  for (screen_no = 0; screen_no < si->nscreens; screen_no++)
+    {
+      ssi = &si->screens[screen_no];
+      screen = ssi->screen;
+      root   = RootWindowOfScreen (screen);
+
+      if (root == root_ret)
+        return ssi;
+    }
+
+  return NULL; /* Didn't match the root on any screen  we know of - PUNT! */
+}
+
+/*
+ 5083155 Unable to unlock screen when running dual-head MAG
+ adding dual or multiple heads for magnifier support
+
+ screen 0: loginhelp can pass the raisedWid of GOK or MAG or both
+           found: return its parent Wid (child of root)
+           not found:  0
+
+ other screen:        MAG only if the target screen no > 0 is selected
+           found:  restack on that screen
+               return 0
+           not-found : return 0
+
+ */
+
+static Window
+check_raisedWid (saver_info *si, Window wid)
+{
+  saver_screen_info *ssi;
+  Screen *screen;
+  Window root, root_ret, parent_ret, *children = NULL;
+  unsigned int nchildren = 0;
+  int screen_no, status;
+
+  status = XQueryTree (si->dpy, wid, &root_ret, &parent_ret,
+                       &children, &nchildren);
+
+  if (status == 0) /* failed */
+    return 0;
+
+  XFree(children);
+  children = NULL;
+
+  for (screen_no = 0; screen_no < si->nscreens; screen_no++)
+    {
+      ssi = &si->screens[screen_no];
+      screen = ssi->screen;
+      root   = RootWindowOfScreen (screen);
+
+      if (root == root_ret)
+        break;
+    }
+
+  if ( screen_no >= si->nscreens ) /* Didn't match the root on any screen */
+    return 0;                      /*  we know of - PUNT!                 */
+
+  /* Climb the tree until we find an ancestor that's a child of root */
+  while ( root_ret != parent_ret )
+    {
+      wid = parent_ret;
+
+      status = XQueryTree (si->dpy, wid, &root_ret, &parent_ret,
+                           &children, &nchildren);
+
+      if (status == 0) /* failed */
+        return 0;
+
+      XFree(children);
+      children = NULL;
+    }
+
+  if ( ssi != si->pw_data->prompt_screen )
+    {
+      /* found in other screen (not the one with the unlock dialog),
+         implies MAG target screen, invoke XRestackWindow() there
+      */
+      Window screen_win[2] = { wid, ssi->screensaver_window };
+      safe_XRestackWindows(si->dpy, screen_win, 2);
+      return 0;   /* no need to do the restack on prompt screen */
+    }
+
+  return wid;
+}
+
+/* Enforce window stacking order when a new window arrives.
+   Only allow raising windows the unlock dialog has told us to raise
+   (including itself).
+ */
+static void
+restack_my_windows (saver_info* si, saver_screen_info *ssi, Window newWin)
+{
+  int n = 0;
+  Window short_stack[EXTRA_RAISE_WIN_SLOTS];
+  Window *restack_list;
+  Bool allowed = False;
+
+  /* If window is on another screen than the unlock dialog,
+     or we have list of no windows to raise */
+  if ((si->raise_wins == NULL) || (ssi != si->pw_data->prompt_screen))
+    {
+      restack_list = short_stack;
+    }
+  else
+    {
+      restack_list = si->raise_wins;
+      for (n = 0; n < si->num_raise_wins; n++)
+        {
+          if (si->raise_wins[n] == newWin)
+            allowed = True;
+        }
+    }
+
+  if (si->passwd_dialog && (ssi == si->pw_data->prompt_screen))
+    {
+      restack_list[n++] = si->passwd_dialog;
+      if (si->passwd_dialog == newWin)
+        allowed = True;
+    }
+
+  if (ssi->stderr_overlay_window)
+    {
+      restack_list[n++] = ssi->stderr_overlay_window;
+      if (ssi->stderr_overlay_window == newWin)
+        allowed = True;
+    }
+
+  if (ssi->screensaver_window)
+    {
+      restack_list[n++] = ssi->screensaver_window;
+      if (ssi->screensaver_window == newWin)
+        allowed = True;
+    }
+
+  /* If it's not in the allowed list, it goes behind
+     the screensaver_window. */
+  if (newWin && !allowed)
+    restack_list[n++] = newWin;
+
+  if (n > 1)
+    safe_XRestackWindows (si->dpy, restack_list, n);
+}
+
+/* Send a command to the xscreensaver-lock child process
+   Arguments:
+    - msg - message to send, such as ul_ok
+    - data - additional data, such as string to display for this message,
+             if any, otherwise NULL
+   Message format sent to child:
+    "msg\n" if no data, otherwise "msg=data\n"
+ */
+int
+write_to_child (saver_info* si, const char* msg, const char *data)
+{
+  if (msg == NULL)
+    {
+      fprintf (stderr, "Invalid null message written to child\n");
+      return -1;
+    }
+
+  if (si->external_passwd && g_passwd_dialog_created &&
+      si->pw_data->stdin_fd != -1)
+    {
+      int len;
+
+      if (si->prefs.verbose_p)
+        {
+          fprintf (stderr,
+                   "@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@\n"
+                   "HAVE_SCRSVR_LOCK writing to fd:%d message is:\n%s=%s\n"
+                   "@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@\n",
+                   si->pw_data->stdin_fd, msg, data ? data : "(null)");
+        }
+
+      if (data)
+        len = fprintf (si->pw_data->stdin_file, "%s=%s\n", msg, data);
+      else
+        len = fprintf (si->pw_data->stdin_file, "%s\n", msg);
+
+      fflush (si->pw_data->stdin_file);
+      return len;
+    }
+
+  return (0); /* if we didn't write anything return 0 */
+}
+
+static int
+sane_dup2 (int fd1, int fd2)
+{
+  int ret;
+
+  do
+    {
+      ret = dup2 (fd1, fd2);
+    }
+  while (ret < 0 && errno == EINTR);
+
+  return ret;
+}
+
+static int
+close_and_invalidate (int *fd)
+{
+  int ret;
+
+  ret = close (*fd);
+  *fd = -1;
+
+  return ret;
+}
+
+void
+handle_passwd_input (XtPointer xtdata, int *fd, XtInputId *id)
+{
+  saver_info *si = (saver_info *)xtdata;
+  saver_preferences *p = &si->prefs;
+  char buffer[1024];
+  char *msg, *data;
+  passwd_dialog_data *pw = si->pw_data;
+
+  if (p->verbose_p)
+    fprintf (stderr, "passwd input handler() fd=%d\n", *fd);
+
+  msg = fgets (buffer, sizeof (buffer), pw->stdout_file);
+  if (!msg)  /* child closed pipe */
+    {
+      if (p->verbose_p)
+        {
+          fprintf (stderr, "done reading...\n");
+          fprintf (stderr, "removing input handler...\n");
+        }
+      XtRemoveInput (*id);
+      pw->stdout_input_id = 0;
+
+      if (p->verbose_p)
+        fprintf (stderr, "passwd input handler() returning...done reading\n");
+
+      return;
+    }
+
+  if (p->verbose_p)
+    fprintf (stderr, "Child sent message: %s\n", msg);
+
+  /* search for =, and if found, split msg & data into two strings there */
+  data = strchr(msg, '=');
+  if (data)
+    {
+      char *nl;
+
+      *data++ = 0;
+
+      /* strip trailing newline */
+      nl = strchr (data, '\n');
+      if (nl)
+        *nl = '\0';
+    }
+  else
+    {
+      /* All the messages we currently expect require data! */
+      if (p->verbose_p)
+        fprintf (stderr, "*** Invalid message: no data found, discarding\n");
+
+      return;
+    }
+
+  if ((strcmp(msg, "input") == 0)) /* User input */
+    {
+      si->unlock_state = ul_finished;
+      pw->got_passwd = TRUE;
+      pw->passwd_string = strdup (data);
+      memset (data, 0, strlen(data));
+    }
+  else if ((strcmp(msg, "ungrab_keyboard") == 0))
+    {
+      /* An accessibility helper needs to access the keyboard, so we have
+         to release our grab - unfortunately this risks other apps acting
+         on keys they shouldn't, so first we disable metacity keys that
+         could allow getting back to the locked session windows, and hope
+         we don't crash or die before restoring them later.
+
+         Other window managers are likely to be risky to use in this case.
+      */
+
+      if (client == NULL)
+        client = gconf_client_get_default();
+
+      if (global_switch_key == NULL)
+        {
+          global_switch_key =
+            gconf_client_get_string (client, switch_windows_gconf_key, NULL);
+
+          if (global_switch_key && strncmp (global_switch_key, "dis", 3))
+            gconf_client_set_string (client, switch_windows_gconf_key,
+                                     "disabled", NULL);
+        }
+
+      if (global_menu_key == NULL)
+        {
+          global_menu_key =
+            gconf_client_get_string (client, main_menu_gconf_key, NULL);
+
+          if (global_menu_key && strncmp(global_menu_key, "dis", 3))
+            gconf_client_set_string (client, main_menu_gconf_key,
+                                     "disabled", NULL);
+        }
+
+      XUngrabKeyboard (si->dpy, CurrentTime);
+      XFlush (si->dpy);
+    }
+  else if ((strcmp(msg, "ungrab_pointer") == 0))
+    {
+      /* An accessibility helper needs to access the mouse, so we have
+         to release our grab - this is simpler, since we don't worry about
+         mouse gestures that may get through, though maybe we should...
+      */
+
+      XUngrabPointer (si->dpy, CurrentTime);
+      XFlush (si->dpy);
+    }
+  else /* Get a window id of an interesting window from the child */
+    {
+      Window window = strtoul (data, NULL, 0);
+      int status;
+
+      if ((strcmp (msg, "dialog_win") == 0))
+        {
+          /* The unlock dialog itself */
+          si->passwd_dialog = window;
+          pw->got_windowid = True;
+
+          move_mouse_grab (si, si->passwd_dialog, pw->passwd_cursor,
+                           pw->prompt_screen->number);
+          undo_vp_motion (si);
+          passwd_animate_timer ((XtPointer) si, 0);
+
+          /* Flush queue of captured typeahead events */
+          if (si->typeahead_events && si->num_typeahead_events)
+            {
+              int i;
+
+              for (i = 0; i < si->num_typeahead_events; i++)
+                {
+                  si->typeahead_events[i].window = window;
+                  safe_XSendEvent (si->dpy, window, False, KeyPressMask,
+                                   (XEvent *) &si->typeahead_events[i]);
+                }
+              si->num_typeahead_events = 0;
+            }
+          XGrabKeyboard (si->dpy, window, True, GrabModeAsync, GrabModeAsync, CurrentTime);
+          XGrabPointer (si->dpy, window, True, 0, GrabModeAsync, GrabModeAsync, None, None, CurrentTime);
+          XFlush (si->dpy);
+          XSetInputFocus (si->dpy, window, RevertToPointerRoot, CurrentTime);
+          XSync (si->dpy, False);
+        }
+      else if ((strcmp (msg, "raise_win") == 0))
+        {
+          /* Accessibility helpers that need to be raised above the
+             full-screen blanking window hiding the user's desktop */
+          Window *newlist;
+          Window overwin;
+
+          if ( (si->num_raise_wins + EXTRA_RAISE_WIN_SLOTS)
+               >= si->max_raise_wins)
+            {
+              int raise_alloc = si->max_raise_wins + WIN_ALLOC_INCREMENT;
+
+              newlist = realloc(si->raise_wins, raise_alloc * sizeof(Window));
+              if (newlist == NULL)
+                return;
+
+              si->raise_wins = newlist;
+              si->max_raise_wins = raise_alloc;
+            }
+
+          overwin = check_raisedWid (si, window);
+          if (overwin)
+            {
+              XWindowAttributes attrs;
+              status = XGetWindowAttributes (si->dpy, overwin, &attrs);
+
+              if ( status && !attrs.override_redirect )
+                {
+                  unsigned long valuemask = CWOverrideRedirect;
+                  XSetWindowAttributes setwinattr;
+                  setwinattr.override_redirect = True;
+
+                  XChangeWindowAttributes (si->dpy, overwin,
+                                           valuemask, &setwinattr);
+
+                  if (si->num_override_wins >= si->max_override_wins)
+                    {
+                      int over_alloc
+                        = si->max_override_wins + WIN_ALLOC_INCREMENT;
+
+                      newlist = realloc(si->override_wins,
+                                        over_alloc * sizeof(Window));
+                      if (newlist == NULL)
+                        return;
+
+                      si->override_wins = newlist;
+                      si->max_override_wins = over_alloc;
+                    }
+
+                  si->override_wins[si->num_override_wins++] = overwin;
+                }
+              XMapSubwindows(si->dpy, overwin);
+              si->raise_wins[si->num_raise_wins++] = overwin;
+            }
+          else
+            si->raise_wins[si->num_raise_wins++] = window;
+        } /* "raise_win" */
+
+      restack_my_windows(si, si->pw_data->prompt_screen, 0);
+    }
+}
+
+/* returns successful fork/exec */
+Bool
+spawn_external_passwd_process (saver_info *si, passwd_dialog_data *pw)
+{
+  saver_preferences *p = &si->prefs;
+  pid_t forked;
+  const char *command = LOCKDIR "/xscreensaver-lock";
+  int stdin_pipe[2]  = { -1, -1 };
+  int stdout_pipe[2] = { -1, -1 };
+
+  si->passwd_pid = 0;
+  pw->stdin_fd = pw->stdout_fd = -1;
+  pw->got_windowid = False;
+
+  if (si->prefs.verbose_p)
+     fprintf(stderr, "-->spawn_external_passwd()\n");
+
+  if (si->passwd_pid > 0)
+    {
+      if (si->prefs.verbose_p)
+        fprintf (stderr,"pid %ld still exists.  Killing it with SIGKILL\n",
+                 si->passwd_pid);
+      kill_job (si, si->passwd_pid, SIGKILL);
+    }
+  si->passwd_pid = 0;
+
+  if (pipe (stdin_pipe) < 0)
+    {
+      perror ("pipe(stdin_pipe) failed!");
+      return False;
+    }
+
+  if (pipe (stdout_pipe) < 0)
+    {
+      perror ("pipe(stdout_pipe) failed!");
+      close_and_invalidate (&stdin_pipe[0]);
+      close_and_invalidate (&stdin_pipe[1]);
+      return False;
+    }
+  switch ((int) (forked = fork ()))
+    {
+    case -1:
+      fprintf (stderr, "%s: ", blurb ());
+      perror ("couldn't fork");
+
+      close_and_invalidate (&stdin_pipe[0]);
+      close_and_invalidate (&stdin_pipe[1]);
+      close_and_invalidate (&stdout_pipe[0]);
+      close_and_invalidate (&stdout_pipe[1]);
+
+      return False;
+
+    case 0:
+      close (ConnectionNumber (si->dpy)); /* close display fd */
+      /* limit_subproc_memory (p->inferior_memory_limit, p->verbose_p); */
+      /* hack_subproc_environment (ssi); */ /* FIX $DISPLAY */
+
+      /* Inside Child Process */
+      if (p->verbose_p)
+        fprintf (stderr, "%s: spawning \"%s\" in pid %lu.\n",
+                 blurb(), command, (unsigned long) getpid ());
+
+      close_and_invalidate (&stdin_pipe[1]);
+      close_and_invalidate (&stdout_pipe[0]);
+
+      sane_dup2 (stdin_pipe[0], 0);  /* Listen to Parent from here */
+      sane_dup2 (stdout_pipe[1], 9); /* Talk to Parent from here */
+
+      /* Make sure we have relinquished setuid privs or lock dialog gtk
+       * program will not run as libgtk is not setuid safe.
+       */
+      hack_uid (si);
+
+      exec_command (p->shell, command, 0);
+      /* print_path_error (command); */
+      fprintf (stderr, "%s: couldn't exec: %s\n",
+               blurb (), command);
+      abort ();
+
+    default:
+      /* In Parent */
+      make_job(forked, 0, command);
+      close_and_invalidate (&stdin_pipe[0]);
+      close_and_invalidate (&stdout_pipe[1]);
+
+      sane_dup2 (stdin_pipe[0], 0);  /* Listen to Child from here */
+      sane_dup2 (stdout_pipe[1], 13); /* Talk to Child from here */
+
+      pw->stdin_fd   = stdin_pipe[1];   /* Talk to child from here */
+      pw->stdout_fd  = stdout_pipe[0];  /* Listen to Child from here */
+      si->passwd_pid = forked;
+
+      /* Messages to child dialog are sent through this pipe/fd */
+      pw->stdin_file = fdopen (pw->stdin_fd, "w");
+      write_to_child (si, "Hello", NULL); /* Send a test message to Child */
+
+      /* Password from child dialog comes through this pipe/fd */
+      pw->stdout_file = fdopen (pw->stdout_fd, "r");
+
+      pw->stdout_input_id = XtAppAddInput (si->app, pw->stdout_fd,
+                                           (XtPointer) XtInputReadMask,
+                                           handle_passwd_input, si);
+
+      /* Set global flag to indicate that lock dialog is visible */
+      g_passwd_dialog_created = True;
+      return True;
+    }
+
+  /* shouldn't reach */
+  abort ();
+  return False;
+}
+#endif /* HAVE_XSCREENSAVER_LOCK */
+
 static int
 new_passwd_window (saver_info *si)
 {
   passwd_dialog_data *pw;
+#ifndef HAVE_XSCREENSAVER_LOCK
   Screen *screen;
   Colormap cmap;
   char *f;
+#endif
   saver_screen_info *ssi = &si->screens [mouse_screen (si)];
 
+#ifdef HAVE_XSCREENSAVER_LOCK
+  /* si->pw_data is globally allocated and never freed when HAVE_XSS_LOCK */
+  pw = si->pw_data;
+  if (!spawn_external_passwd_process (si, pw))
+    return -1;
+  si->external_passwd = True;
+#else
   pw = (passwd_dialog_data *) calloc (1, sizeof(*pw));
   if (!pw)
     return -1;
@@ -199,17 +716,21 @@ new_passwd_window (saver_info *si)
    */
   pw->login_button_p = (si->prefs.new_login_command &&
                         *si->prefs.new_login_command);
+#endif
 
   pw->passwd_cursor = XCreateFontCursor (si->dpy, XC_top_left_arrow);
 
   pw->prompt_screen = ssi;
 
+#ifndef HAVE_XSCREENSAVER_LOCK
   screen = pw->prompt_screen->screen;
   cmap = DefaultColormapOfScreen (screen);
+#endif
 
   pw->show_stars_p = get_boolean_resource(si->dpy, "passwd.asterisks", 
 					  "Boolean");
   
+#ifndef HAVE_XSCREENSAVER_LOCK
   pw->heading_label = get_string_resource (si->dpy, "passwd.heading.label",
 					   "Dialog.Label.Label");
   pw->body_label = get_string_resource (si->dpy, "passwd.body.label",
@@ -358,6 +879,7 @@ new_passwd_window (saver_info *si)
   if (pw->shadow_width == 0) pw->shadow_width = 4;
   if (pw->thermo_width == 0) pw->thermo_width = pw->shadow_width;
 
+#endif /* ! HAVE_XSCREENSAVER_LOCK */
 
   /* We need to remember the mouse position and restore it afterward, or
      sometimes (perhaps only with Xinerama?) the mouse gets warped to
@@ -422,12 +944,16 @@ make_passwd_window (saver_info *si,
 		    const char *prompt,
 		    Bool echo)
 {
+#ifndef HAVE_XSCREENSAVER_LOCK
   XSetWindowAttributes attrs;
   unsigned long attrmask = 0;
+#endif
   passwd_dialog_data *pw;
+#ifndef HAVE_XSCREENSAVER_LOCK
   Screen *screen;
   Colormap cmap;
   Dimension max_string_width_px;
+#endif
   saver_screen_info *ssi = &si->screens [mouse_screen (si)];
 
   cleanup_passwd_window (si);
@@ -435,7 +961,12 @@ make_passwd_window (saver_info *si,
   if (! ssi)   /* WTF?  Trying to prompt while no screens connected? */
     return -1;
 
+#ifdef HAVE_XSCREENSAVER_LOCK
+  /* si->pw_data is globally allocated and never freed when HAVE_XSS_LOCK */
+  if (!si->pw_data->got_windowid)
+#else
   if (!si->pw_data)
+#endif
     if (new_passwd_window (si) < 0)
       return -1;
 
@@ -450,6 +981,29 @@ make_passwd_window (saver_info *si,
              blurb(), pw->prompt_screen->number,
              info_msg ? info_msg : "");
 
+#ifdef HAVE_XSCREENSAVER_LOCK
+  /* Wipe the old password, so we get prompted to enter new password. */
+  if (pw->passwd_string)
+    {
+      memset(pw->passwd_string, 0, strlen (pw->passwd_string));
+      free (pw->passwd_string);
+      pw->passwd_string = NULL;
+    }
+
+  if (info_msg)
+    write_to_child (si, "ul_message", info_msg);
+  if (prompt)
+    {
+      write_to_child (si, "ul_pamprompt", prompt);
+
+      if (echo)
+        write_to_child (si, "ul_prompt_echo", "true");
+      else if (pw->show_stars_p)
+        write_to_child (si, "ul_prompt_echo", "stars");
+      else
+        write_to_child (si, "ul_prompt_echo", "false");
+    }
+#else
   screen = pw->prompt_screen->screen;
   cmap = DefaultColormapOfScreen (screen);
 
@@ -687,11 +1241,13 @@ make_passwd_window (saver_info *si,
   if (cmap)
     XInstallColormap (si->dpy, cmap);
   draw_passwd_window (si);
+#endif /* ! HAVE_XSCREENSAVER_LOCK */
 
   return 0;
 }
 
 
+#ifndef HAVE_XSCREENSAVER_LOCK
 static void
 draw_passwd_window (saver_info *si)
 {
@@ -1035,17 +1591,48 @@ draw_button(Display *dpy,
   draw_shaded_rectangle(dpy, dialog, x, y, width, height,
 			shadow_width, shadow_light, shadow_dark);
 }
+#endif /* !HAVE_XSCREENSAVER_LOCK */
 
 static void
 update_passwd_window (saver_info *si, const char *printed_passwd, float ratio)
 {
   passwd_dialog_data *pw = si->pw_data;
+#ifndef HAVE_XSCREENSAVER_LOCK
   XGCValues gcv;
   GC gc1, gc2;
   int x, y;
   XRectangle rects[1];
+#endif
 
   pw->ratio = ratio;
+
+#ifdef HAVE_XSCREENSAVER_LOCK
+  /* Send countdown timer ratio to child lock dialog */
+  if (si->passwd_dialog)
+    {
+      XEvent event;
+
+      event.xany.type = ClientMessage;
+      event.xclient.display = si->dpy;
+      event.xclient.window = si->passwd_dialog;
+      event.xclient.message_type = XA_UNLOCK_RATIO;
+      event.xclient.format = 32;
+      memset (&event.xclient.data, 0, sizeof (event.xclient.data));
+      event.xclient.data.l[0] = (long)(pw->ratio * 100);
+      event.xclient.data.l[1] = 0;
+      event.xclient.data.l[2] = 0;
+
+      if (!safe_XSendEvent (si->dpy, si->passwd_dialog, False, 0L, &event))
+        fprintf (stderr, "%s: error sending ratio to lock dialog\n", blurb ());
+    }
+  else
+    {
+      if (si->prefs.verbose_p)
+        fprintf (stderr,
+          "-->update_passwd_window() lockdialog not created, returning!!\n");
+      return;
+    }
+#else
   gcv.foreground = pw->passwd_foreground;
   gcv.font = pw->passwd_font->fid;
   gc1 = XCreateGC (si->dpy, si->passwd_dialog, GCForeground|GCFont, &gcv);
@@ -1187,6 +1774,7 @@ update_passwd_window (saver_info *si, const char *printed_passwd, float ratio)
   XFreeGC (si->dpy, gc1);
   XFreeGC (si->dpy, gc2);
   XSync (si->dpy, False);
+#endif /* !HAVE_XSCREENSAVER_LOCK */
 }
 
 
@@ -1218,6 +1806,9 @@ cleanup_passwd_window (saver_info *si)
 {
   passwd_dialog_data *pw;
 
+  if (si->prefs.verbose_p)
+    fprintf (stderr, "cleanup_passwd_window\n");
+
   if (!(pw = si->pw_data))
     return;
 
@@ -1234,7 +1825,12 @@ cleanup_passwd_window (saver_info *si)
     }
 
   memset (pw->typed_passwd, 0, sizeof(pw->typed_passwd));
-  memset (pw->passwd_string, 0, strlen(pw->passwd_string));
+  if (pw->passwd_string)
+    {
+      memset (pw->passwd_string, 0, strlen(pw->passwd_string));
+      free (pw->passwd_string);
+      pw->passwd_string = NULL;
+    }
 
   if (pw->timer)
     {
@@ -1257,8 +1853,10 @@ destroy_passwd_window (saver_info *si)
   passwd_dialog_data *pw = si->pw_data;
   saver_screen_info *ssi = pw->prompt_screen;
   Colormap cmap = DefaultColormapOfScreen (ssi->screen);
+#ifndef HAVE_XSCREENSAVER_LOCK
   Pixel black = BlackPixelOfScreen (ssi->screen);
   Pixel white = WhitePixelOfScreen (ssi->screen);
+#endif
   XEvent event;
 
   cleanup_passwd_window (si);
@@ -1274,6 +1872,81 @@ destroy_passwd_window (saver_info *si)
       si->cached_passwd = NULL;
     }
 
+#ifdef HAVE_XSCREENSAVER_LOCK
+  /* reset global flag to indicate passwd dialog is no longer there */
+  g_passwd_dialog_created = False;
+
+  if (si->external_passwd)
+    {
+      /* kill the child etc. */
+      write_to_child (si, "cmd_exit", NULL);
+
+      if (pw->stdin_file)
+        fclose (pw->stdin_file);
+      if (pw->stdin_fd != -1)
+        close_and_invalidate (&pw->stdin_fd);
+      if (pw->stdout_input_id)
+        XtRemoveInput (pw->stdout_input_id);
+      if (pw->stdout_file)
+        fclose (pw->stdout_file);
+      else if (pw->stdout_fd != -1)
+        close_and_invalidate (&pw->stdout_fd);
+
+      if (si->passwd_pid)
+        {
+          kill_job (si, si->passwd_pid, SIGTERM);
+          si->passwd_pid = 0;
+        }
+
+      free (si->raise_wins);
+      si->raise_wins = NULL;
+      si->num_raise_wins = 0;
+      si->max_raise_wins = 0;
+
+      if (si->override_wins)
+        {
+          int n;
+
+          unsigned long valuemask = CWOverrideRedirect;
+          XSetWindowAttributes setwinattr;
+          setwinattr.override_redirect = False;
+
+          for (n = 0; n < si->num_override_wins; n++)
+            {
+              XChangeWindowAttributes (si->dpy, si->override_wins[n],
+                                       valuemask, &setwinattr);
+            }
+          free(si->override_wins);
+          si->override_wins = NULL;
+        }
+      si->num_override_wins = 0;
+      si->max_override_wins = 0;
+
+      si->pw_data->got_windowid = False;
+      si->external_passwd = False;
+
+      /* restore any metacity keys we temporarily disabled */
+      if (client)
+        {
+          if (global_switch_key)
+            {
+              gconf_client_set_string (client, switch_windows_gconf_key,
+                                       global_switch_key, NULL);
+              g_free(global_switch_key);
+              global_switch_key = NULL;
+            }
+
+          if (global_menu_key)
+            {
+              gconf_client_set_string (client, main_menu_gconf_key,
+                                       global_menu_key, NULL);
+              g_free(global_menu_key);
+              global_menu_key = NULL;
+            }
+        }
+    }
+#endif /* HAVE_XSCREENSAVER_LOCK */
+
   move_mouse_grab (si, RootWindowOfScreen (ssi->screen),
                    ssi->cursor, ssi->number);
 
@@ -1308,7 +1981,14 @@ destroy_passwd_window (saver_info *si)
         fprintf (stderr, "%s: %d: destroying password dialog.\n",
                  blurb(), pw->prompt_screen->number);
 
+#ifdef HAVE_XSCREENSAVER_LOCK
+      /* Ignore X error if window was already closed by the child,
+         and make sure any VisibilityNotify events are removed
+         from the event queue before we forget the window id. */
+      safe_XDestroyWindow (si->dpy, si->passwd_dialog);
+#else
       XDestroyWindow (si->dpy, si->passwd_dialog);
+#endif
       si->passwd_dialog = 0;
     }
   
@@ -1319,6 +1999,7 @@ destroy_passwd_window (saver_info *si)
       pw->save_under = 0;
     }
 
+#ifndef HAVE_XSCREENSAVER_LOCK
   if (pw->heading_label) free (pw->heading_label);
   if (pw->body_label)    free (pw->body_label);
   if (pw->user_label)    free (pw->user_label);
